/**
 * PrintInfo.h
 *
 * This file is part of the LibTiePie programming examples.
 *
 * Find more information on http://www.tiepie.com/LibTiePie .
 */

#ifndef _PRINTINFO_H_
#define _PRINTINFO_H_

#include <libtiepie++.h>

// Print library info:
void printLibraryInfo();

// Print device info:
void printDeviceInfo(const LibTiePie::Device* device);

// Print oscilloscope info:
void printOscilloscopeInfo(const LibTiePie::Oscilloscope* scp);

// Print generator info:
void printGeneratorInfo(const LibTiePie::Generator* gen);

// Print I2C info:
void printI2CInfo(const LibTiePie::I2CHost* i2c);

// Print trigger input info:
void printTriggerInputsInfo(const LibTiePie::TriggerInputs& TriggerInputs);

// Print trigger output info:
void printTriggerOutputsInfo(const LibTiePie::TriggerOutputs& TriggerOutputs);

// String conversion functions:
std::string generatorModeToStr(const uint64_t generatorModes);
std::string clockOutputToStr(const uint32_t clockOutputs);
std::string clockSourceToStr(const uint32_t clockSources);
std::string connectorTypeToStr(const uint32_t connectorTypes);
std::string convertDate(const TpDate_t date);
std::string convertVersion(const TpVersion_t version);
std::string couplingToStr(const uint64_t couplings);
std::string dataRawTypeToStr(const uint32_t dataRawTypes);
std::string deviceTypeToStr(const uint32_t deviceTypes);
std::string frequencyModeToStr(const uint32_t frequencyModes);
std::string measureModeToStr(const uint32_t dwMeasureModes);
std::string autoResolutionModeToStr(const uint32_t autoResolutions);
std::string signalTypeToStr(const uint32_t signalTypes);
std::string triggerConditionToStr(const uint32_t triggerConditions);
std::string triggerKindToStr(const uint64_t triggerKinds);
std::string triggerLevelModeToStr(const uint32_t triggerLevelModes);
std::string triggerOutputEventToStr(const uint64_t triggerEvents);
std::string boolToStr(const bool value);

#endif
